(* Code of union example in ML on pages 203-204
   Kenneth C. Louden, Programming Languages
   Principles and Practice 2nd Edition
   Copyright (C) Brooks-Cole/ITP, 2003
*)

datatype IntOrReal = IsInt of int | IsReal of real;

val x = IsReal(2.3);

fun printInt x =
   (print("int: "); print(Int.toString x); print("\n"));

fun printReal x =
   (print("real: "); print(Real.toString x); print("\n"))

fun printIntOrReal x =
  case x of
    IsInt(i) => printInt i |
    IsReal(r) =>printReal r ;

printIntOrReal(x); (* prints "real: 2.3" *)
printIntOrReal (IsInt 42); (* prints "int: 42" *)

